#ifndef Initialisierung_H
#define Initialisierung_H

#include <Fenster.h>
#include <Knopf.h>
#include <TextFeld.h>
#include <Schrift.h>
#include <initializer_list>
#include <AuswahlBox.h>
#include <Tabelle.h>
#include <Bild.h>
#include <Diagramm.h>
#include <Fortschritt.h>
#include <Liste.h>

using namespace Framework;

struct OBJTabelleSpalteIni
{
	const char* name;
	int breite;
	int minBreite;
	int maxBreite;
};

#define ABSTYLE AuswahlBox::Style::Sichtbar | AuswahlBox::Style::Erlaubt | AuswahlBox::Style::Rahmen | AuswahlBox::Style::AuswahlBuffer | AuswahlBox::Style::MausBuffer | AuswahlBox::Style::MaxHeight | AuswahlBox::Style::Hintergrund | AuswahlBox::Style::VScroll
#define OTSTYLE ObjTabelle::Style::Sichtbar | ObjTabelle::Style::Erlaubt | ObjTabelle::Style::Rahmen | ObjTabelle::Style::Raster

Knopf* initKnopf(int x, int y, int br, int h, __int64 style, const char* titel);
KontrollKnopf* initKontrollKnopf(int x, int y, int br, int h, __int64 style, const char* txt);
Fenster* initFenster(int x, int y, int br, int h, __int64 style, const char* titel);
TextFeld* initTextFeld(int x, int y, int br, int h, __int64 style, const char* txt);
BildZ* initBildZ(int x, int y, int br, int h, __int64 style, Bild* b);
AuswahlBox* initAuswahlBox(int x, int y, int br, int h, __int64 style, std::initializer_list< const char* > values);
ObjTabelle* initObjTabelle(int x, int y, int br, int h, __int64 style, std::initializer_list< OBJTabelleSpalteIni > spalten, int berschriftHhe);
LDiag* initLinienDiagramm(int x, int y, int br, int h, __int64 style, DiagDaten* data);
FBalken* initFBalken(int x, int y, int br, int h, __int64 style);
AuswahlListe* initAuswahlListe(int x, int y, int br, int h, __int64 style, std::initializer_list< const char* > values);
ZeichnungHintergrund* initZeichnungHintergrund(int x, int y, int br, int h, __int64 style, int farbe);
void initToolTip(Zeichnung* obj, const char* txt);

#endif