#ifndef KarteAuswahl_H
#define KarteAuswahl_H

#include <Klient.h>
#include <Bild.h>
#include <Knopf.h>
#include <Thread.h>
#include <KSGScript.h>
#include <Rahmen.h>

using namespace Framework;
using namespace KSGScript;

class KarteDaten : public virtual ReferenceCounter
{
private:
    class Loader : public Thread
    {
    private:
        KarteDaten *kd;
        int aktion;
    public:
        Loader( KarteDaten *kd, int aktion );
        void thread() override;
        int getAction() const;
    };
    Loader *loader;
    int karteId;
    Bild *hintergrund;
    HINSTANCE ksgs;
    KSGScriptObj *beschreibung;
    LRahmen *rahmen;
    double tickVal;
    int animation;
    bool ausgewhlt;
    Punkt pos;
    Punkt gr;
    int geladen;
    AlphaFeld *auswahl;
    unsigned char auswAlpha;
    bool erlaubt;
    bool rend;
    unsigned char tAlpha;
    unsigned char alpha;
    friend Loader;

public:
    // Konstruktor
    KarteDaten( int id );
    // Destruktor
    ~KarteDaten();
    // nicht constant
    void updateErlaubt();
    void ksgsAktion( RCArray< KSGSVariable > *parameter, KSGSVariable **retVal );
    void setSichtbar( bool sichtbar );
    void setSichtbar();
    void setAuswahl( bool auswahl );
    void setPosition( int lPos );
    bool tick( double tickVal );
    void doPublicMausEreignis( MausEreignis &me );
    void render( Bild &zRObj );
    // constant
    int getKarteId() const;
    bool istausgewhlt() const;
};

class KarteAuswahlFenster : public Thread
{
private:
    int anzahl;
    int auswahl;
    RCArray< KarteDaten > *members;
    LRahmen *rahmen;
    TextRenderer *tr;
    double tickVal;
    int animation;
    Punkt pos;
    Punkt gr;
    int spielId;
    int seite;
    bool rend;
    unsigned char alpha;

public:
    // Konstruktor
    KarteAuswahlFenster();
    // Destruktor
    ~KarteAuswahlFenster();
    // nicht constant
    void setSpielId( int spielId );
    void setSichtbar( bool sichtbar );
    void blttern( bool oben );
    void updateListe();
    virtual void thread();
    bool tick( double tickVal );
    void doPublicMausEreignis( MausEreignis &me );
    void render( Bild &zrObj );
    // constant
    int getAnzahl() const;
    int getSeiteAnzahl() const;
    int getSeite() const;
    int getAnzahlAufSeite() const;
    bool hatAuswahl() const;
    KarteDaten *getAuswahl() const;
};

#endif