#ifndef SpielStatistik_H
#define SpielStatistik_H

#include <SpielStatistikV.h>
#include <Animation.h>

class SpielStatistik : public virtual ReferenceCounter
{
private:
	SpielStatistikV* stat;
	Punkt pos;
	Punkt gr;
	HINSTANCE spielDll;
	Animation2D* la;
	double tickVal;
	bool sichtbar;
	unsigned char alpha;
	int spielArt;
	bool rend;

public:
	// Konstruktor
	SpielStatistik();
	// Destruktor
	~SpielStatistik();
	// nicht constant
	void setSpielArt(int spielArt);
	void nachricht(int ln, const char* bytes);
	void reset();
	void doPublicMausEreignis(MausEreignis& me);
	void doTastaturEreignis(TastaturEreignis& te);
	bool tick(double zeit);
	void render(Bild& zRObj);
	void addNachrichtF(Text* t, Text* n, Text* rp, Text* rn);
	void addChatF(int acc);
	void addFreundF(int acc);
	void accountAnsehenF(int acc);
	bool istFreundF(int acc);
	void verlassen();
	// constant
	bool istSichtbar();
};

// Rckruf Funktionen
void spielStatistikAddNachrichtF(void* p, Text* t, Text* n, Text* rp, Text* rn);
void spielStatistikAddChatF(void* p, int acc);
void spielStatistikAddFreundF(void* p, int acc);
void spielStatistikAccountAnsehenF(void* p, int acc);
bool spielStatistikIstFreundF(void* p, int acc);

#endif