#ifndef Geheimnis_H
#define Geheimnis_H

#include <Knopf.h>
#include <Fenster.h>
#include <TextFeld.h>
#include <Schrift.h>
#include <Bildschirm.h>
#include "..\..\Aktionen\AktionsThread.h"

using namespace Framework;

class Geheimnisndern : public virtual ReferenceCounter
{
private:
    Knopf *geheimnisndern;
    Fenster *fenster;
    TextFeld *name;
    TextFeld *passwort;
    TextFeld *geheimnis;
    TextFeld *nGeheimnis;
    Knopf *weiter;
    TextFeld *nachricht;
    void zeigeNachricht( const char *txt );

public:
    // Konstruktor
    Geheimnisndern( Fenster *zVorLoginFenster );
    // Destruktor
    ~Geheimnisndern();
    // Knopfdruck
    void druckFremdKnopf(); // Ein anderer Knopf wurde gedrckt
    bool geheimnisndernME( void *obj, MausEreignis me ); // MausEreignis im Knopf geheimnisndern
    bool nameTE( void *obj, TastaturEreignis te ); // Tastaturereignis im Textfeld name
    bool passwortTE( void *obj, TastaturEreignis te ); // Tastaturereignis im Textfeld passwort
    bool geheimnisTE( void *obj, TastaturEreignis te ); // Tastaturereignis im Textfeld geheimnis
    bool nGeheimnisTE( void *obj, TastaturEreignis te ); // Tastaturereignis im Textfeld nGeheimnis
    bool weiterME( void *obj, MausEreignis me ); // MausEreignis im Knopf weiter
    void setResult( bool ret ); // Setzt den Returnwert
};

class GeheimnisVergessen : public virtual ReferenceCounter
{
private:
    Knopf *geheimnisVergessen;
    Fenster *fenster;
    TextFeld *name;
    TextFeld *passwort;
    Knopf *weiter;
    TextFeld *nachricht;
    void zeigeNachricht( const char *txt );

public:
    // Konstruktor
    GeheimnisVergessen( Fenster *zVorLoginFenster );
    // Destruktor
    ~GeheimnisVergessen();
    // Knopfdruck
    void druckFremdKnopf(); // Ein anderer Knopf wurde gedrckt
    bool geheimnisVergessenME( void *obj, MausEreignis me ); // MausEreignis im Knopf geheimnisVergessen
    bool nameTE( void *obj, TastaturEreignis te ); // Tastaturereignis im Textfeld name
    bool passwortTE( void *obj, TastaturEreignis te ); // Tastaturereignis im Textfeld passwort
    bool weiterME( void *obj, MausEreignis me ); // MausEreignis im Knopf weiter
    void setResult( bool ret ); // Setzt den Returnwert
};

// messages
bool geheimnisndernGeheimnisndernME( void *p, void *obj, MausEreignis me );
bool geheimnisndernNameTE( void *p, void *obj, TastaturEreignis te );
bool geheimnisndernPasswortTE( void *p, void *obj, TastaturEreignis te );
bool geheimnisndernGeheimnisTE( void *p, void *obj, TastaturEreignis te );
bool geheimnisndernNGeheimnisTE( void *p, void *obj, TastaturEreignis te );
bool geheimnisndernWeiterME( void *p, void *obj, MausEreignis me );

bool geheimnisVergessenGeheimnisVergessenME( void *p, void *obj, MausEreignis me );
bool geheimnisVergessenNameTE( void *p, void *obj, TastaturEreignis te );
bool geheimnisVergessenPasswortTE( void *p, void *obj, TastaturEreignis te );
bool geheimnisVergessenWeiterME( void *p, void *obj, MausEreignis me );

#endif