#include "VorLogin.h"
#include "..\Global\Initialisierung.h"
#include "..\Global\Variablen.h"

// Inhalt der VorLogin Klasse aus VorLogin.h
// Konstruktor 
VorLogin::VorLogin()
    : ReferenceCounter()
{
    fenster = 0;
    beenden = 0;
    login = 0;
    eMailndern = 0;
    eMailVergessen = 0;
    geheimnisndern = 0;
    geheimnisVergessen = 0;
    nameVergessen = 0;
    passwortndern = 0;
    passwortVergessen = 0;
    registrierung = 0;
    unregistrierung = 0;
}

// Destruktor 
VorLogin::~VorLogin()
{
    if( fenster )
        setSichtbar( 0 );
}

// nicht constant
void VorLogin::setSichtbar( bool s ) // Setzt die Sichtbarkeit der VorLogin Oberfrche
{
    if( s )
    {
        if( fenster )
            setSichtbar( 0 );
        fenster = uiFactory.createFenster( uiFactory.initParam );
        fenster->addStyle( Fenster::Style::Erlaubt | Fenster::Style::Sichtbar );
        fenster->setSize( uiFactory.initParam.bildschirm->getBackBufferSize() );
        fenster->setPosition( 0, 0 );
        beenden = initKnopf( 10, 10, 130, 30, Knopf::Style::Sichtbar, "Beenden" );
        beenden->setMausEreignis( VorLoginBeendenME );
        initToolTip( beenden, "Beendet den Kolja-Strohm Games Client." );
        fenster->addMember( beenden );
        login = new Login( fenster );
        eMailndern = new EMailndern( fenster );
        eMailVergessen = new EMailVergessen( fenster );
        geheimnisndern = new Geheimnisndern( fenster );
        geheimnisVergessen = new GeheimnisVergessen( fenster );
        nameVergessen = new NameVergessen( fenster );
        passwortndern = new Passwortndern( fenster );
        passwortVergessen = new PasswortVergessen( fenster );
        registrierung = new Registrierung( fenster );
        unregistrierung = new Unregistrierung( fenster );
        uiFactory.initParam.bildschirm->addMember( fenster );
    }
    else
    {
        uiFactory.initParam.bildschirm->lock();
        if( uiFactory.initParam.bildschirm )
            uiFactory.initParam.bildschirm->removeMember( fenster );
        if( login )
            login = (Login *)login->release();
        if( eMailndern )
            eMailndern = (EMailndern *)eMailndern->release();
        if( eMailVergessen )
            eMailVergessen = (EMailVergessen *)eMailVergessen->release();
        if( geheimnisndern )
            geheimnisndern = (Geheimnisndern *)geheimnisndern->release();
        if( geheimnisVergessen )
            geheimnisVergessen = (GeheimnisVergessen *)geheimnisVergessen->release();
        if( nameVergessen )
            nameVergessen = (NameVergessen *)nameVergessen->release();
        if( passwortndern )
            passwortndern = (Passwortndern *)passwortndern->release();
        if( passwortVergessen )
            passwortVergessen = (PasswortVergessen *)passwortVergessen->release();
        if( registrierung )
            registrierung = (Registrierung *)registrierung->release();
        if( unregistrierung )
            unregistrierung = (Unregistrierung *)unregistrierung->release();
        if( fenster )
            fenster = (Fenster *)fenster->release();
        uiFactory.initParam.bildschirm->unlock();
    }
}

void VorLogin::setLogin( bool knopfPress ) // macht Login Oberflche sichtbar
{
    if( !knopfPress )
    {
        MausEreignis me;
        me.id = ME_RLinks;
        if( login )
            login->loginME( 0, me );
        return;
    }
    if( registrierung )
        registrierung->druckFremdKnopf();
    if( unregistrierung )
        unregistrierung->druckFremdKnopf();
    if( passwortndern )
        passwortndern->druckFremdKnopf();
    if( passwortVergessen )
        passwortVergessen->druckFremdKnopf();
    if( eMailndern )
        eMailndern->druckFremdKnopf();
    if( eMailVergessen )
        eMailVergessen->druckFremdKnopf();
    if( geheimnisndern )
        geheimnisndern->druckFremdKnopf();
    if( geheimnisVergessen )
        geheimnisVergessen->druckFremdKnopf();
    if( nameVergessen )
        nameVergessen->druckFremdKnopf();
}

void VorLogin::setEMailndern() // macht EMailndern Oberflche sichtbar
{
    if( registrierung )
        registrierung->druckFremdKnopf();
    if( unregistrierung )
        unregistrierung->druckFremdKnopf();
    if( passwortndern )
        passwortndern->druckFremdKnopf();
    if( passwortVergessen )
        passwortVergessen->druckFremdKnopf();
    if( eMailVergessen )
        eMailVergessen->druckFremdKnopf();
    if( geheimnisndern )
        geheimnisndern->druckFremdKnopf();
    if( geheimnisVergessen )
        geheimnisVergessen->druckFremdKnopf();
    if( nameVergessen )
        nameVergessen->druckFremdKnopf();
    if( login )
        login->druckFremdKnopf();
}

void VorLogin::setEMailVergessen() // macht EMailVergessen Oberflche sichtbar
{
    if( registrierung )
        registrierung->druckFremdKnopf();
    if( unregistrierung )
        unregistrierung->druckFremdKnopf();
    if( passwortndern )
        passwortndern->druckFremdKnopf();
    if( passwortVergessen )
        passwortVergessen->druckFremdKnopf();
    if( eMailndern )
        eMailndern->druckFremdKnopf();
    if( geheimnisndern )
        geheimnisndern->druckFremdKnopf();
    if( geheimnisVergessen )
        geheimnisVergessen->druckFremdKnopf();
    if( nameVergessen )
        nameVergessen->druckFremdKnopf();
    if( login )
        login->druckFremdKnopf();
}

void VorLogin::setGeheimnisndern() // macht Geheimnisndern Oberflche sichtbar
{
    if( registrierung )
        registrierung->druckFremdKnopf();
    if( unregistrierung )
        unregistrierung->druckFremdKnopf();
    if( passwortndern )
        passwortndern->druckFremdKnopf();
    if( passwortVergessen )
        passwortVergessen->druckFremdKnopf();
    if( eMailndern )
        eMailndern->druckFremdKnopf();
    if( eMailVergessen )
        eMailVergessen->druckFremdKnopf();
    if( geheimnisVergessen )
        geheimnisVergessen->druckFremdKnopf();
    if( nameVergessen )
        nameVergessen->druckFremdKnopf();
    if( login )
        login->druckFremdKnopf();
}

void VorLogin::setGeheilnisVergessen() // macht GeheimnisVergessen Oberflche sichtbar
{
    if( registrierung )
        registrierung->druckFremdKnopf();
    if( unregistrierung )
        unregistrierung->druckFremdKnopf();
    if( passwortndern )
        passwortndern->druckFremdKnopf();
    if( passwortVergessen )
        passwortVergessen->druckFremdKnopf();
    if( eMailndern )
        eMailndern->druckFremdKnopf();
    if( eMailVergessen )
        eMailVergessen->druckFremdKnopf();
    if( geheimnisndern )
        geheimnisndern->druckFremdKnopf();
    if( nameVergessen )
        nameVergessen->druckFremdKnopf();
    if( login )
        login->druckFremdKnopf();
}

void VorLogin::setNameVergessen() // macht NameVergessen Oberflche sichtbar
{
    if( registrierung )
        registrierung->druckFremdKnopf();
    if( unregistrierung )
        unregistrierung->druckFremdKnopf();
    if( passwortndern )
        passwortndern->druckFremdKnopf();
    if( passwortVergessen )
        passwortVergessen->druckFremdKnopf();
    if( eMailndern )
        eMailndern->druckFremdKnopf();
    if( eMailVergessen )
        eMailVergessen->druckFremdKnopf();
    if( geheimnisndern )
        geheimnisndern->druckFremdKnopf();
    if( geheimnisVergessen )
        geheimnisVergessen->druckFremdKnopf();
    if( login )
        login->druckFremdKnopf();
}

void VorLogin::setPasswortndern() // macht Passwortndern Oberflche sichtbar
{
    if( registrierung )
        registrierung->druckFremdKnopf();
    if( unregistrierung )
        unregistrierung->druckFremdKnopf();
    if( nameVergessen )
        nameVergessen->druckFremdKnopf();
    if( passwortVergessen )
        passwortVergessen->druckFremdKnopf();
    if( eMailndern )
        eMailndern->druckFremdKnopf();
    if( eMailVergessen )
        eMailVergessen->druckFremdKnopf();
    if( geheimnisndern )
        geheimnisndern->druckFremdKnopf();
    if( geheimnisVergessen )
        geheimnisVergessen->druckFremdKnopf();
    if( login )
        login->druckFremdKnopf();
}

void VorLogin::setPasswortVergessen() // macht passwortVergessen Oberflche sichtbar
{
    if( registrierung )
        registrierung->druckFremdKnopf();
    if( unregistrierung )
        unregistrierung->druckFremdKnopf();
    if( nameVergessen )
        nameVergessen->druckFremdKnopf();
    if( passwortndern )
        passwortndern->druckFremdKnopf();
    if( eMailndern )
        eMailndern->druckFremdKnopf();
    if( eMailVergessen )
        eMailVergessen->druckFremdKnopf();
    if( geheimnisndern )
        geheimnisndern->druckFremdKnopf();
    if( geheimnisVergessen )
        geheimnisVergessen->druckFremdKnopf();
    if( login )
        login->druckFremdKnopf();
}

void VorLogin::setRegistrierung() // macht Registrierung Oberflche sichtbar
{
    if( passwortVergessen )
        passwortVergessen->druckFremdKnopf();
    if( unregistrierung )
        unregistrierung->druckFremdKnopf();
    if( nameVergessen )
        nameVergessen->druckFremdKnopf();
    if( passwortndern )
        passwortndern->druckFremdKnopf();
    if( eMailndern )
        eMailndern->druckFremdKnopf();
    if( eMailVergessen )
        eMailVergessen->druckFremdKnopf();
    if( geheimnisndern )
        geheimnisndern->druckFremdKnopf();
    if( geheimnisVergessen )
        geheimnisVergessen->druckFremdKnopf();
    if( login )
        login->druckFremdKnopf();
}

void VorLogin::setUnregistrierung() // macht Unregistrierung Oberflche sichtbar
{
    if( passwortVergessen )
        passwortVergessen->druckFremdKnopf();
    if( registrierung )
        registrierung->druckFremdKnopf();
    if( nameVergessen )
        nameVergessen->druckFremdKnopf();
    if( passwortndern )
        passwortndern->druckFremdKnopf();
    if( eMailndern )
        eMailndern->druckFremdKnopf();
    if( eMailVergessen )
        eMailVergessen->druckFremdKnopf();
    if( geheimnisndern )
        geheimnisndern->druckFremdKnopf();
    if( geheimnisVergessen )
        geheimnisVergessen->druckFremdKnopf();
    if( login )
        login->druckFremdKnopf();
}

// constant
Login *VorLogin::getLogin() const // gibt die Login Oberflche zurck
{
    return login ? dynamic_cast<Login *>( login->getThis() ) : 0;
}

Login *VorLogin::zLogin() const
{
    return login;
}

EMailndern *VorLogin::getEMailndern() const // gibt die EMailndern Oberflche zurck
{
    return eMailndern ? dynamic_cast<EMailndern *>( eMailndern->getThis() ) : 0;
}

EMailndern *VorLogin::zEMailndern() const
{
    return eMailndern;
}

EMailVergessen *VorLogin::getEMailVergessen() const // gibt die EMailVergessen Oberflche zurck
{
    return eMailVergessen ? dynamic_cast<EMailVergessen *>( eMailVergessen->getThis() ) : 0;
}

EMailVergessen *VorLogin::zEMailVergessen() const
{
    return eMailVergessen;
}

Geheimnisndern *VorLogin::getGeheimnisndern() const // gibt die Geheimnisndern Oberflche zurck
{
    return geheimnisndern ? dynamic_cast<Geheimnisndern *>( geheimnisndern->getThis() ) : 0;
}

Geheimnisndern *VorLogin::zGeheimnisndern() const
{
    return geheimnisndern;
}

GeheimnisVergessen *VorLogin::getGeheimnisVergessen() const // gibt die GeheimnisVergessen Oberflche zurck
{
    return geheimnisVergessen ? dynamic_cast<GeheimnisVergessen *>( geheimnisVergessen->getThis() ) : 0;
}

GeheimnisVergessen *VorLogin::zGeheimnisVergessen() const
{
    return geheimnisVergessen;
}

NameVergessen *VorLogin::getNameVergessen() const // gibt die NameVergessen Oberflche zurck
{
    return nameVergessen ? dynamic_cast<NameVergessen *>( nameVergessen->getThis() ) : 0;
}

NameVergessen *VorLogin::zNameVergessen() const
{
    return nameVergessen;
}

Passwortndern *VorLogin::getPasswortndern() const // gibt die Passwortndern Oberflche zurck
{
    return passwortndern ? dynamic_cast<Passwortndern *>( passwortndern->getThis() ) : 0;
}

Passwortndern *VorLogin::zPasswortndern() const
{
    return passwortndern;
}

PasswortVergessen *VorLogin::getPasswortVergessen() const // gibt die PasswortVergessen Oberflche zurck
{
    return passwortVergessen ? dynamic_cast<PasswortVergessen *>( passwortVergessen->getThis() ) : 0;
}

PasswortVergessen *VorLogin::zPasswortVergessen() const
{
    return passwortVergessen;
}

Registrierung *VorLogin::getRegistrierung() const // gibt die Registrierung Oberflche zurck
{
    return registrierung ? dynamic_cast<Registrierung *>( registrierung->getThis() ) : 0;
}

Registrierung *VorLogin::zRegistrierung() const
{
    return registrierung;
}

Unregistrierung *VorLogin::getUnregistrierung() const // gibt die Unregistrierung Oberflche zurck
{
    return unregistrierung ? dynamic_cast<Unregistrierung *>( unregistrierung->getThis() ) : 0;
}

Unregistrierung *VorLogin::zUnregistrierung() const
{
    return unregistrierung;
}

Fenster *VorLogin::zFenster() const
{
    return fenster;
}

// Ereignisse
bool VorLoginBeendenME( void *p, void *obj, MausEreignis me )
{
    if( me.id == ME_RLinks )
        PostQuitMessage( 0 );
    return 1;
}